// Font routines and loader
// (C) 1999 Jay Cook
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <mem.h>
#include <alloc.h>
typedef unsigned char  byte;
typedef unsigned int word;
typedef unsigned long  dword;
int FontX2, FontY2, FNum;

struct JFONT1
 {  // for Object list
  dword far *Font1;
 } JFont[93];

//////////////////////////
void InitFont()
//////////////////////////
{  // Sets up Font info in mem
 int SpriteR,k; // 8x8(64 bytes -1) font size
 SpriteR = 70 * sizeof(dword);// 4,599 bytes of memory
  for(k=0;k<93;k++)
   JFont[k].Font1=farmalloc(SpriteR);
}

//////////////////////////
void FreeFont()
//////////////////////////
{  // Frees memory before quiting
  int k;
  for(k=0;k<93;k++)
   farfree(JFont[k].Font1);
}

//////////////////////////
void GetFont()
//////////////////////////
{  // Puts font graphics into memory
  int FX1,FY1,k;
  k=0;
  for(FX1=0; FX1<13;FX1++)
  {
   k++;
   SpriteGet(FX1*9+1,37, JFont[k].Font1);
  }
  for(FX1=0; FX1<19;FX1++)
  {
   k++;
   SpriteGet(FX1*9+1,46, JFont[k].Font1);
  }
  for(FX1=0; FX1<32;FX1++)
  {
   k++;
   SpriteGet(FX1*9+1,55, JFont[k].Font1);
  }
  for(FX1=0; FX1<26;FX1++)
  {
   k++;
   SpriteGet(FX1*9+1,64, JFont[k].Font1);
  }
}

//////////////////////////
void GCFont (int FontX1, int FontY1, char TextFont)
//////////////////////////
{  // For printing single characters on the screen
 int n2,n2max;
 FontX2=(FontX1*8)-16;
 FontY2=(FontY1*8)-8;
 FNum=TextFont-32;
 if(FNum>0) SpriteDraw(FontX2,FontY2, JFont[FNum].Font1);
}

//////////////////////////
void GFont (int FontX1, int FontY1, char TextFont[150])
//////////////////////////
{  // For printing entire strings on the screen
 int n2,n2max;
 FontX2=(FontX1*8)-16;
 FontY2=(FontY1*8)-8;
 n2max=(strlen(TextFont));
 for(n2=0;n2<n2max;n2++)
 {
  FNum=TextFont[n2]-32;
  FontX2=FontX2+8;
  if(FNum>0) SpriteDraw(FontX2,FontY2, JFont[FNum].Font1);
 }
}
